function [p,r] = compute_pr(q,b,c,a)
% function [p,r] = compute_pr(q,b,c)

q = q(:);
b = b(:);
c = c(:);
m = length(q)-1;
T = toeplitz([q(end:-1:1) ; zeros(m,1)],[q(end) zeros(1,m)]);
H = hankel([zeros(m-1,1) ; q ; 0],zeros(1,m));
A = [T H];
B = [0.5*(b(end:-1:2)+c(end:-1:1)) ; b(1) ; 0.5*(b(2:end)-c)];
x = A\B;
p = x(1:(m+1));
r = x((m+2):end);

t = linspace(0,2,500)';
at = cos(t*(0:m))*[1;a];
bt = cos(t*(0:m))*b;
ct = sin(t*(1:m))*c;
z = exp(j*t);
figure(1); plot(t,abs(polyval(p,z)./polyval(q,z)));
figure(2); plot(t,abs(polyval(r,conj(z))./polyval(q,conj(z))));
%figure(3); plot(t,abs(polyval(p,z)./polyval(q,z)+polyval(r,conj(z))./polyval(q,conj(z))));
N = polyval(p,exp(j*t)).*polyval(q,exp(-j*t))+polyval(r,exp(-j*t)).*polyval(q,exp(j*t));
figure(3); plot(t,abs(N./abs(polyval(q,z)).^2),t,abs((bt+j*ct)./at));

% t = linspace(0,pi,500)';
% N = polyval(p,exp(j*t)).*polyval(q,exp(-j*t))+polyval(r,exp(-j*t)).*polyval(q,exp(j*t));
% figure(1);
% plot(t,cos(t*(0:m))*b-real(N));
% figure(2);
% plot(t,sin(t*(1:m))*c-imag(N));